'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _styled = require('styled-components');
var React = require('react');
var index = require('./index-00b34fc0.js');
var ButtonBase = require('./ButtonBase.js');
var Theme = require('./Theme.js');
var constants = require('./constants.js');
require('./extends-338edd51.js');
require('./FocusVisible.js');
require('./defineProperty-26e0e7dd.js');
require('./keycodes.js');
require('./text-styles.js');
require('./font.js');
require('./css.js');
require('./theme-dark.js');
require('./theme-light.js');
require('./environment.js');
require('./miscellaneous.js');
require('./color.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _styled__default = /*#__PURE__*/_interopDefaultLegacy(_styled);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

function PaginationItem(_ref) {
  let {
    touchMode,
    selected,
    index,
    onChange
  } = _ref;
  const theme = Theme.useTheme();
  const handleClick = React.useCallback(() => {
    onChange(index);
  }, [index, onChange]);
  return /*#__PURE__*/React__default["default"].createElement("div", null, /*#__PURE__*/React__default["default"].createElement(_StyledButtonBase, {
    onClick: handleClick,
    focusRingRadius: constants.RADIUS,
    disabled: selected,
    $_css: (touchMode ? 4 : 3) * constants.GU,
    $_css2: (touchMode ? 4 : 3) * constants.GU,
    $_css3: theme.content,
    $_css4: theme.accentAlternative,
    $_css5: theme.contentInverted,
    $_css6: selected && _styled.css(["&&{background:", ";color:", ";}"], theme.accentAlternative, theme.contentInverted)
  }, /*#__PURE__*/React__default["default"].createElement(_StyledSpan, null, index + 1)));
}

PaginationItem.propTypes = {
  index: index.PropTypes.number.isRequired,
  onChange: index.PropTypes.func.isRequired,
  selected: index.PropTypes.bool.isRequired,
  touchMode: index.PropTypes.bool.isRequired
};

var _StyledButtonBase = _styled__default["default"](ButtonBase["default"]).withConfig({
  displayName: "PaginationItem___StyledButtonBase",
  componentId: "sc-gjr0fz-0"
})(["width:", "px;height:", "px;color:", ";border-radius:", "px;&:active{background:", ";color:", ";}", ";"], p => p.$_css, p => p.$_css2, p => p.$_css3, constants.RADIUS, p => p.$_css4, p => p.$_css5, p => p.$_css6);

var _StyledSpan = _styled__default["default"]("span").withConfig({
  displayName: "PaginationItem___StyledSpan",
  componentId: "sc-gjr0fz-1"
})(["position:relative;top:1px;"]);

exports.PaginationItem = PaginationItem;
//# sourceMappingURL=PaginationItem.js.map
