import _extends from '../../../node_modules/.pnpm/@babel_runtime@7.16.3/node_modules/@babel/runtime/helpers/extends.js';
import _styled from 'styled-components';
import React from 'react';
import PropTypes from '../../../node_modules/.pnpm/prop-types@15.7.2/node_modules/prop-types/index.js';
import { useInside as o, Inside as i } from '../../../node_modules/.pnpm/use-inside@0.2.0_react@16.14.0/node_modules/use-inside/dist/index.js';
import { useLayout } from '../Layout/Layout.js';
import { useTheme } from '../../theme/Theme.js';
import { RADIUS, GU } from '../../style/constants.js';
import { textStyle } from '../../style/text-styles.js';

function Box(_ref) {
  let {
    heading,
    children,
    padding,
    ...props
  } = _ref;
  const theme = useTheme();
  const [insideSplitPrimary] = o('Split:primary');
  const {
    layoutName
  } = useLayout();
  const fullWidth = layoutName === 'small';
  const defaultPadding = (fullWidth ? 2 : insideSplitPrimary ? 5 : 3) * GU;
  const contentPadding = padding === undefined ? defaultPadding : padding;
  return /*#__PURE__*/React.createElement(i, {
    name: "Box"
  }, /*#__PURE__*/React.createElement(_StyledDiv, _extends({
    as: heading ? 'section' : 'div'
  }, props, {
    $_css: fullWidth ? 0 : RADIUS,
    $_css2: theme.surfaceContent,
    $_css3: 2 * GU
  }), heading && /*#__PURE__*/React.createElement(_StyledH, {
    $_css4: 4 * GU,
    $_css5: defaultPadding,
    $_css6: theme.tableBorder,
    $_css7: theme.surfaceContentSecondary,
    $_css8: textStyle('label2')
  }, /*#__PURE__*/React.createElement(i, {
    name: "Box:heading"
  }, heading)), /*#__PURE__*/React.createElement(_StyledDiv2, {
    $_css9: contentPadding
  }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(i, {
    name: "Box:content"
  }, children)))));
}

Box.propTypes = {
  heading: PropTypes.node,
  children: PropTypes.node,
  padding: PropTypes.oneOfType([PropTypes.number])
};

var _StyledDiv = _styled("div").withConfig({
  displayName: "Box___StyledDiv",
  componentId: "sc-w2ziiv-0"
})(["position:relative;border-radius:", "px;border-style:solid;border-width:0px;color:", ";& + &{margin-top:", "px;}"], p => p.$_css, p => p.$_css2, p => p.$_css3);

var _StyledH = _styled("h1").withConfig({
  displayName: "Box___StyledH",
  componentId: "sc-w2ziiv-1"
})(["display:flex;align-items:center;height:", "px;padding:0 ", "px;border-bottom:1px solid ", ";color:", ";", ";"], p => p.$_css4, p => p.$_css5, p => p.$_css6, p => p.$_css7, p => p.$_css8);

var _StyledDiv2 = _styled("div").withConfig({
  displayName: "Box___StyledDiv2",
  componentId: "sc-w2ziiv-2"
})(["padding:", "px;"], p => p.$_css9);

export { Box as default };
//# sourceMappingURL=Box.js.map
