import _extends from '../../../node_modules/.pnpm/@babel_runtime@7.16.3/node_modules/@babel/runtime/helpers/extends.js';
import _styled from 'styled-components';
import React from 'react';
import PropTypes from '../../../node_modules/.pnpm/prop-types@15.7.2/node_modules/prop-types/index.js';
import ButtonBaseWithFocus from '../ButtonBase/ButtonBase.js';
import { useTheme } from '../../theme/Theme.js';
import { RADIUS } from '../../style/constants.js';

function Link(_ref) {
  let {
    onClick,
    href,
    external,
    ...props
  } = _ref;
  const theme = useTheme(); // `external` defaults to `true` if `href` is present, `false` otherwise.

  if (external === undefined) {
    external = Boolean(href);
  }

  return /*#__PURE__*/React.createElement(_StyledButtonBase, _extends({
    href: href,
    onClick: onClick,
    external: external,
    focusRingSpacing: [6, 2],
    focusRingRadius: RADIUS
  }, props, {
    $_css: theme.accent
  }));
}

Link.propTypes = { ...ButtonBaseWithFocus.propTypes,
  href: PropTypes.string,
  onClick: PropTypes.func,
  external: PropTypes.bool
};

var _StyledButtonBase = _styled(ButtonBaseWithFocus).withConfig({
  displayName: "Link___StyledButtonBase",
  componentId: "sc-123ih76-0"
})(["color:", ";text-decoration:none;font-size:inherit;&:hover{text-decoration:underline;}"], p => p.$_css);

export { Link as default };
//# sourceMappingURL=Link.js.map
