import _styled, { css } from 'styled-components';
import React, { useCallback } from 'react';
import PropTypes from '../../../node_modules/.pnpm/prop-types@15.7.2/node_modules/prop-types/index.js';
import ButtonBaseWithFocus from '../ButtonBase/ButtonBase.js';
import { useTheme } from '../../theme/Theme.js';
import { RADIUS, GU } from '../../style/constants.js';

function PaginationItem(_ref) {
  let {
    touchMode,
    selected,
    index,
    onChange
  } = _ref;
  const theme = useTheme();
  const handleClick = useCallback(() => {
    onChange(index);
  }, [index, onChange]);
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(_StyledButtonBase, {
    onClick: handleClick,
    focusRingRadius: RADIUS,
    disabled: selected,
    $_css: (touchMode ? 4 : 3) * GU,
    $_css2: (touchMode ? 4 : 3) * GU,
    $_css3: theme.content,
    $_css4: theme.accentAlternative,
    $_css5: theme.contentInverted,
    $_css6: selected && css(["&&{background:", ";color:", ";}"], theme.accentAlternative, theme.contentInverted)
  }, /*#__PURE__*/React.createElement(_StyledSpan, null, index + 1)));
}

PaginationItem.propTypes = {
  index: PropTypes.number.isRequired,
  onChange: PropTypes.func.isRequired,
  selected: PropTypes.bool.isRequired,
  touchMode: PropTypes.bool.isRequired
};

var _StyledButtonBase = _styled(ButtonBaseWithFocus).withConfig({
  displayName: "PaginationItem___StyledButtonBase",
  componentId: "sc-gjr0fz-0"
})(["width:", "px;height:", "px;color:", ";border-radius:", "px;&:active{background:", ";color:", ";}", ";"], p => p.$_css, p => p.$_css2, p => p.$_css3, RADIUS, p => p.$_css4, p => p.$_css5, p => p.$_css6);

var _StyledSpan = _styled("span").withConfig({
  displayName: "PaginationItem___StyledSpan",
  componentId: "sc-gjr0fz-1"
})(["position:relative;top:1px;"]);

export { PaginationItem };
//# sourceMappingURL=PaginationItem.js.map
