import _extends from '../../../node_modules/.pnpm/@babel_runtime@7.16.3/node_modules/@babel/runtime/helpers/extends.js';
import _styled from 'styled-components';
import React from 'react';
import PropTypes from '../../../node_modules/.pnpm/prop-types@15.7.2/node_modules/prop-types/index.js';
import { Inside as i } from '../../../node_modules/.pnpm/use-inside@0.2.0_react@16.14.0/node_modules/use-inside/dist/index.js';
import { useViewport as me } from '../../../node_modules/.pnpm/use-viewport@0.2.0_react@16.14.0/node_modules/use-viewport/dist/index.js';
import { GU } from '../../style/constants.js';

function Split(_ref) {
  let {
    primary,
    secondary,
    invert,
    secondaryWidth,
    ...props
  } = _ref;
  const {
    within
  } = me();
  const oneColumn = within(-1, 'medium');
  const inverted = !oneColumn && invert === 'horizontal' || oneColumn && invert === 'vertical';
  const primaryContent = /*#__PURE__*/React.createElement(i, {
    name: "Split:primary"
  }, /*#__PURE__*/React.createElement(_StyledDiv, {
    $_css: !oneColumn && inverted ? 4 * GU : 0,
    $_css2: oneColumn && inverted ? 4 * GU : 0
  }, primary));
  const secondaryContent = /*#__PURE__*/React.createElement(i, {
    name: "Split:secondary"
  }, /*#__PURE__*/React.createElement(_StyledDiv2, {
    $_css3: secondaryWidth && !oneColumn ? secondaryWidth : oneColumn ? '100%' : `${46 * GU}px`,
    $_css4: !oneColumn && !inverted ? 4 * GU : 0,
    $_css5: oneColumn && !inverted ? 4 * GU : 0
  }, secondary));
  return /*#__PURE__*/React.createElement(i, {
    name: "Split"
  }, /*#__PURE__*/React.createElement(_StyledDiv3, _extends({}, props, {
    $_css6: oneColumn ? 'block' : 'flex'
  }), inverted ? secondaryContent : primaryContent, inverted ? primaryContent : secondaryContent));
}

Split.propTypes = {
  invert: PropTypes.oneOf(['none', 'horizontal', 'vertical']),
  primary: PropTypes.node,
  secondary: PropTypes.node,
  secondaryWidth: PropTypes.string
};
Split.defaultProps = {
  invert: 'none'
};

var _StyledDiv = _styled("div").withConfig({
  displayName: "Split___StyledDiv",
  componentId: "sc-15h5hna-0"
})(["flex-grow:1;margin-left:", "px;padding-top:", "px;"], p => p.$_css, p => p.$_css2);

var _StyledDiv2 = _styled("div").withConfig({
  displayName: "Split___StyledDiv2",
  componentId: "sc-15h5hna-1"
})(["flex-shrink:0;flex-grow:0;width:", ";margin-left:", "px;padding-top:", "px;"], p => p.$_css3, p => p.$_css4, p => p.$_css5);

var _StyledDiv3 = _styled("div").withConfig({
  displayName: "Split___StyledDiv3",
  componentId: "sc-15h5hna-2"
})(["display:", ";width:100%;"], p => p.$_css6);

export { Split, Split as default };
//# sourceMappingURL=Split.js.map
